! AIF 2
! Include between Parser and VerbLib

[ PrefaceByArticle o acode pluralise capitalise  i artform findout
    artval;
   if (o provides articles) {
       ! --Addition
       if (metaclass(o.&articles-->0)==Routine)
       {
	  i = o.articles(acode+short_name_case*LanguageCases);
	  if (i==0 or 1) print (char)' ';
	  if (i~=-1)
	  {
	     if (pluralise) return;
	     print (PSN__) o; return;
	  }
       }
       else 
       { ! --end
  	  artval=(o.&articles)-->(acode+short_name_case*LanguageCases);
          if (capitalise)
             print (Cap) artval, (char)' ';
          else
             print (string) artval, (char)' ';
       
          if (pluralise) return;
          print (PSN__) o; return;
       } ! this also
    }

    i = GetGNAOfObject(o);
    if (pluralise) {
        if (i < 3 || (i >= 6 && i < 9)) i = i + 3;
    }
    i = LanguageGNAsToArticles-->i;

    artform = LanguageArticles
        + 3*WORDSIZE*LanguageContractionForms*(short_name_case + i*LanguageCases);

    #Iftrue (LanguageContractionForms == 2);
    if (artform-->acode ~= artform-->(acode+3)) findout = true;
    #Endif; ! LanguageContractionForms
    #Iftrue (LanguageContractionForms == 3);
    if (artform-->acode ~= artform-->(acode+3)) findout = true;
    if (artform-->(acode+3) ~= artform-->(acode+6)) findout = true;
    #Endif; ! LanguageContractionForms
    #Iftrue (LanguageContractionForms == 4);
    if (artform-->acode ~= artform-->(acode+3)) findout = true;
    if (artform-->(acode+3) ~= artform-->(acode+6)) findout = true;
    if (artform-->(acode+6) ~= artform-->(acode+9)) findout = true;
    #Endif; ! LanguageContractionForms
    #Iftrue (LanguageContractionForms > 4);
    findout = true;
    #Endif; ! LanguageContractionForms

    #Ifdef TARGET_ZCODE;
    if (standard_interpreter ~= 0 && findout) {
        StorageForShortName-->0 = 160;
        @output_stream 3 StorageForShortName;
        if (pluralise) print (number) pluralise; else print (PSN__) o;
        @output_stream -3;
        acode = acode + 3*LanguageContraction(StorageForShortName + 2);
    }
    #Ifnot; ! TARGET_GLULX
    if (findout) {
        if (pluralise)
            PrintAnyToArray(StorageForShortName, 160, EnglishNumber, pluralise);
        else
            PrintAnyToArray(StorageForShortName, 160, PSN__, o);
        acode = acode + 3*LanguageContraction(StorageForShortName);
    }
    #Endif; ! TARGET_

    Cap (artform-->acode, ~~capitalise); ! print article
    if (pluralise) return;
    print (PSN__) o;
];

[ Identical o1 o2 p1 p2 n1 n2 i j flag;
    if (o1 == o2) rtrue;  ! This should never happen, but to be on the safe side
    if (o1 == 0 || o2 == 0) rfalse;  ! Similarly
    if (parent(o1) == compass || parent(o2) == compass) rfalse; ! Saves time

    !  What complicates things is that o1 or o2 might have a parsing routine,
    !  so the parser can't know from here whether they are or aren't the same.
    !  If they have different parsing routines, we simply assume they're
    !  different.  If they have the same routine (which they probably got from
    !  a class definition) then the decision process is as follows:
    !
    !     the routine is called (with self being o1, not that it matters)
    !       with noun and second being set to o1 and o2, and action being set
    !       to the fake action TheSame.  If it returns -1, they are found
    !       identical; if -2, different; and if >=0, then the usual method
    !       is used instead.

    if (o1.parse_name ~= 0 || o2.parse_name ~= 0) {
      if (o1.parse_name ~= o2.parse_name) rfalse;
      parser_action = ##TheSame; parser_one = o1; parser_two = o2;
      j = wn; i = RunRoutines(o1,parse_name); wn = j;
      if (i == -1) rtrue;
      if (i == -2) rfalse;
    }
   if (ParseNounTheSame) ! <-- use this. it's good. --'trix
   {
      parser_one = o1; parser_two = o2;
      parser_action = ##TheSame;
      i = ParseNounTheSame(o1,o2);
      if (i==1) rtrue;
      if (i==0) rfalse;
   }

    !  This is the default algorithm: do they have the same words in their
    !  "name" (i.e. property no. 1) properties.  (Note that the following allows
    !  for repeated words and words in different orders.)

    p1 = o1.&1; n1 = (o1.#1)/WORDSIZE;
    p2 = o2.&1; n2 = (o2.#1)/WORDSIZE;

    !  for (i=0 : i<n1 : i++) { print (address) p1-->i, " "; } new_line;
    !  for (i=0 : i<n2 : i++) { print (address) p2-->i, " "; } new_line;

    for (i=0 : i<n1 : i++) {
        flag = 0;
        for (j=0 : j<n2 : j++)
            if (p1-->i == p2-->j) flag = 1;
        if (flag == 0) rfalse;
    }

    for (j=0 : j<n2 : j++) {
        flag = 0;
        for (i=0 : i<n1 : i++)
            if (p1-->i == p2-->j) flag = 1;
        if (flag == 0) rfalse;
    }

    !  print "Which are identical!^";
    rtrue;
];

[ Adjudicate context i j k good_flag good_ones last n flag offset sovert;
    #Ifdef DEBUG;
    if (parser_trace >= 4) {
        print "   [Adjudicating match list of size ", number_matched, " in context ", context, "^";
        print "   ";
        if (indef_mode) {
            print "indefinite type: ";
            if (indef_type & OTHER_BIT)  print "other ";
            if (indef_type & MY_BIT)     print "my ";
            if (indef_type & THAT_BIT)   print "that ";
            if (indef_type & PLURAL_BIT) print "plural ";
            if (indef_type & LIT_BIT)    print "lit ";
            if (indef_type & UNLIT_BIT)  print "unlit ";
            if (indef_owner ~= 0) print "owner:", (name) indef_owner;
            new_line;
            print "   number wanted: ";
            if (indef_wanted == 100) print "all"; else print indef_wanted;
            new_line;
            print "   most likely GNAs of names: ", indef_cases, "^";
        }
        else print "definite object^";
    }
    #Endif; ! DEBUG

    j = number_matched-1; good_ones = 0; last = match_list-->0;
    for (i=0 : i<=j : i++) {
        n = match_list-->i;
        match_scores-->i = 0;

        good_flag = false;

        switch (context) {
          HELD_TOKEN:
            if (parent(n) == actor or gj_container) good_flag = true;
	  MULTIHELD_TOKEN:
	    if (parent(n) == actor) good_flag = true;
          MULTIEXCEPT_TOKEN:
            if (advance_warning == -1) {
                good_flag = true;
            }
            else {
                if (n ~= advance_warning) good_flag = true;
            }
          MULTIINSIDE_TOKEN:
            if (advance_warning == -1) {
                if (parent(n) ~= actor) good_flag = true;
            }
            else {
                if (n in advance_warning) good_flag = true;
            }
          CREATURE_TOKEN:
            if (CreatureTest(n) == 1) good_flag = true;
          default:
            good_flag = true;
        }

        if (good_flag) {
            match_scores-->i = SCORE__IFGOOD;
            good_ones++; last = n;
        }
    }
    if (good_ones == 1) return last;

    ! If there is ambiguity about what was typed, but it definitely wasn't
    ! animate as required, then return anything; higher up in the parser
    ! a suitable error will be given.  (This prevents a question being asked.)

    if (context == CREATURE_TOKEN && good_ones == 0) return match_list-->0;

    if (indef_mode == 0) indef_type=0;

    ScoreMatchL(context);
    if (number_matched == 0) return -1;

    if (indef_mode == 0) {
        !  Is there now a single highest-scoring object?
        i = SingleBestGuess();
        if (i >= 0) {

            #Ifdef DEBUG;
            if (parser_trace >= 4) print "   Single best-scoring object returned.]^";
            #Endif; ! DEBUG
            return i;
        }
    }

    if (indef_mode == 1 && indef_type & PLURAL_BIT ~= 0) {
        if (context ~= MULTI_TOKEN or MULTIHELD_TOKEN or MULTIEXCEPT_TOKEN
                     or MULTIINSIDE_TOKEN) {
            etype = MULTI_PE;
            return -1;
        }
        i = 0; offset = multiple_object-->0; sovert = -1;
        for (j=BestGuess() : j~=-1 && i<indef_wanted && i+offset<63 : j=BestGuess()) {
            flag = 0;
            if (j hasnt concealed && j hasnt worn) flag = 1;
            if (sovert == -1) sovert = bestguess_score/SCORE__DIVISOR;
            else {
                if (indef_wanted == 100 && bestguess_score/SCORE__DIVISOR < sovert)
                    flag = 0;
            }
            if (context == MULTIHELD_TOKEN or MULTIEXCEPT_TOKEN && parent(j) ~= actor)
                flag = 0;
            if (action_to_be == ##Take or ##Remove && parent(j) == actor)
                flag = 0;
            k = ChooseObjects(j, flag);
            if (k == 1)
                flag = 1;
            else {
                if (k == 2) flag = 0;
            }
            if (flag == 1) {
                i++; multiple_object-->(i+offset) = j;
                #Ifdef DEBUG;
                if (parser_trace >= 4) print "   Accepting it^";
                #Endif; ! DEBUG
            }
            else {
                i = i;
                #Ifdef DEBUG;
                if (parser_trace >= 4) print "   Rejecting it^";
                #Endif; ! DEBUG
            }
        }
        if (i < indef_wanted && indef_wanted < 100) {
            etype = TOOFEW_PE; multi_wanted = indef_wanted;
            multi_had=i;
            return -1;
        }
        multiple_object-->0 = i+offset;
        multi_context = context;
        #Ifdef DEBUG;
        if (parser_trace >= 4)
            print "   Made multiple object of size ", i, "]^";
        #Endif; ! DEBUG
        return 1;
    }

    for (i=0 : i<number_matched : i++) match_classes-->i = 0;

    n = 1;
    for (i=0 : i<number_matched : i++)
        if (match_classes-->i == 0) {
            match_classes-->i = n++; flag = 0;
            for (j=i+1 : j<number_matched : j++)
                if (match_classes-->j == 0 && Identical(match_list-->i, match_list-->j) == 1) {
                    flag=1;
                    match_classes-->j = match_classes-->i;
                }
            if (flag == 1) match_classes-->i = 1-n;
        }
     n--; number_of_classes = n;

    #Ifdef DEBUG;
    if (parser_trace >= 4) {
        print "   Grouped into ", n, " possibilities by name:^";
        for (i=0 : i<number_matched : i++)
            if (match_classes-->i > 0)
                print "   ", (The) match_list-->i, " (", match_list-->i, ")  ---  group ",
                  match_classes-->i, "^";
    }
    #Endif; ! DEBUG

    if (indef_mode == 0) {
        if (n > 1) {
            k = -1;
            for (i=0 : i<number_matched : i++) {
                if (match_scores-->i > k) {
                    k = match_scores-->i;
                    j = match_classes-->i; j = j*j;
                    flag = 0;
                }
                else
                    if (match_scores-->i == k) {
                        if ((match_classes-->i) * (match_classes-->i) ~= j)
                            flag = 1;
                    }
            }

        if (flag) {
            #Ifdef DEBUG;
            if (parser_trace >= 4) print "   Unable to choose best group, so ask player.]^";
            #Endif; ! DEBUG
            return 0;
        }
        #Ifdef DEBUG;
        if (parser_trace >= 4) print "   Best choices are all from the same group.^";
        #Endif; ! DEBUG
        }
    }

    !  When the player is really vague, or there's a single collection of
    !  indistinguishable objects to choose from, choose the one the player
    !  most recently acquired, or if the player has none of them, then
    !  the one most recently put where it is.

    if (n == 1) dont_infer = true;
    return BestGuess();

]; ! Adjudicate

[ PronounsSub x y c d;
    L__M(##Pronouns, 1);

    c = (LanguagePronouns-->0)/3;
    if (print_player_flag && player ~= selfobj) c++;

    if (c == 0) return L__M(##Pronouns, 4);

    for (x=1,d=0 : x<=LanguagePronouns-->0 : x=x+3) {
        print "~", (address) LanguagePronouns-->x, "~ ";
       
       y = LanguagePronouns-->(x+2);
        if (y == NULL) L__M(##Pronouns, 3);
        else {
            L__M(##Pronouns, 2);
            print (the) y;
        }
        d++;
        if (d < c-1) print (string) COMMA__TX;
        if (d == c-1) print (string) AND__TX;
    }
    if (print_player_flag && player ~= selfobj) {
        print "~", (address) ME1__WD, "~ "; L__M(##Pronouns, 2);
        c = player; player = selfobj;
        print (the) c; player = c;
    }
    L__M(##Pronouns, 5);
];

Property additive adj;
Property additive words NULL;

[ OwnerOf o;
   if (o)
   {
      if (o provides owner)
      {
	 if (metaclass(o.owner) == Routine)
	    return o.owner();
	 return o.owner;
      }
      if (o ofclass BodyPart) return parent(o);
   }
   rfalse;
];

! Parameters:
!  o1, o2 -- the two objects in question
! Returns:
!  true   -- the objects are indistinguishable
!  false  -- the objects are different
[ ParseNounTheSame o1 o2
    i1 i2 n1 n2 p1 p2 f;
   if (o1 provides words && o1.#words) p1 = o1.&words-->0;
   if (o2 provides words && o2.#words) p2 = o2.&words-->0;
   if (p1==NULL) p1 = 0; if (p2==NULL) p2 = 0;
   ! ask o1.words to decide
   if (p1)
   {
      n1 = wn;
      i1 = RunRoutines(o1,words);
      wn = n1;
      if (i1==-1) rtrue;
      if (i1==-2) rfalse;
      if (p2==0) rfalse;
   }
   ! ask o2.words to decide
   if (p2 && p2~=p1)
   {
      n1 = wn;
      i1 = RunRoutines(o2,words);
      wn = n1;
      if (i1==-1) rtrue;
      rfalse; ! o2.words~=o1.words
   }
   ! check owners
   if (ownerOf(o1)~=ownerOf(o2)) rfalse;

   ! check names
   i1 = o1.&name; n1 = (o1.#name)/WORDSIZE;
   i2 = o2.&name; n2 = (o2.#name)/WORDSIZE;
   for (p1=0:p1<n1:p1++)
   {
      f = false;
      for (p2=0:p2<n2:p2++)
      	 if (i1-->p1 == i2-->p2) { f = true; break; }
      if (f==0) rfalse;
   }
   for (p2=0:p2<n2:p2++)
   {
      f = false;
      for (p2=0:p2<n2:p2++)
	 if (i1-->p1 == i2-->p2) { f = true; break; }
      if (f==0) rfalse;
   }
   ! check adjectives
   i1 = o1.&adj; n1 = (o1.#adj)/WORDSIZE;
   i2 = o2.&adj; n2 = (o2.#adj)/WORDSIZE;
   for (p1=0:p1<n1:p1++)
   {
      f = false;
      for (p2=0:p2<n2:p2++)
      	 if (i1-->p1 == i2-->p2) { f = true; break; }
      if (f==0) rfalse;
   }
   for (p2=0:p2<n2:p2++)
   {
      f = false;
      for (p2=0:p2<n2:p2++)
	 if (i1-->p1 == i2-->p2) { f = true; break; }
      if (f==0) rfalse;
   }
   rtrue;
];
! obj.words(w) can return
!  name, adj, plural, article, articles, 0, other
!  name - accept (nouns, e.g. "book")
!  adj  - accept if with a name (or a plural) (e.g. "red")
!  plural - accept as plural name (e.g. "books")
!  article - accept if followed by a name or adj (e.g. "of")
!  articles - accept as plural if followed by
!             a name or adj (e.g. "pairs")
!  0 - reject (but check name and adj properties)
!  other - reject and don't check other properties
[ ParseNoun obj
    i j w f b pl pb swn ow k;
   swn = wn;
   ow = ownerOf(obj);
   
   if (ow)
   {
      if (indef_owner~=ow or 0) rfalse;
      if (ow~=player && (indef_type&MY_BIT)) rfalse;
      switch (PronounFor(ow))
      {
     	'me':   f = 'my';    j = 'mine';
     	'her':  f = 'her';   j = 'hers';
     	'him':  f = 'his';   j = 'his';
     	'them': f = 'their'; j = 'theirs';
     	'it':   f = 'its';   j = 'its';
      }
      w = NextWord();
      if (w==f or j || (w=='your' && ow == actor))
      {
	 swn = wn; i++;
      }
      if (~~(ow provides genitive or words)) ow = 0;
   }
   f = 0; j = 0;
   for (::i++)
   {
      wn = swn;
      w = NextWord();
      swn = wn;
      if (w==0) break;
      ! skip articles in case the parser missed them (does happen).
      if (i==0 && w=='the' or 'a//' or 'an' or 'some')
	 continue;
      if (i==0 or 1 && obj has openable)
      {
	 if (w=='open' && obj has open) continue;
	 if (w=='closed' && obj hasnt open) continue;
      }
#ifdef CUM_COATING;
      if (obj==pc_breasts or pc_face or pc_pussy &&
	  w=='cum-coat' or 'cum-cove' or 'spunk-co'
	  or 'semen-co' or 'sperm-co' or 'jizz-coa'
	  or 'jizz-cov' or 'seed-coa' or 'seed-cov')
      {
	 if (isSpunked(obj)) continue;
      }
#endif;
      f = PNMatchWord(w,obj);
      
      if (f == name)   {            j = 1; continue; }
      if (f == adj)    { if (b)     j = 1; continue; }
      if (f == plural) { pl = true; j = 1; continue; }
      if (f == article)
      {
 	 if (j)
	 {
	    b = i;
	    pb = pl;
	 }
	 j = 0; pl = 0;
	 continue;
      }
      if (f==articles)
      {
	 if (j)
	 {
	    b = i;
	    pb = pl;
	 }
	 j = 0; pl = 1;
	 continue;
      }
      if (f==0) ! so far unmatched
      {
	 if (ow && k==0) ! if we have an owner
	    ! and no genitives used so far
	 {
	    k = ParseGenitivePhrase(ow,obj);
	    ! if we've matched a genitive phrase,
	    !  increase i and carry on.
	    if (k)
 	    {  i = i+k;
 	       swn = swn + k - 1; ! this line is a late addition
 	       continue;
 	    }
	    ! k is left set to whatever > 0
	    !  so genitives won't be checked again.
	 }
	 break;
      }
   }
   if (j && i)
   {
      if (pl) parser_action = ##PluralFound;
      return i;
   }
   if (b)
   {
      if (pb) parser_action = ##PluralFound;
      return b;
   }
   rfalse;
];

[ ParseGenitivePhrase ow obj
    w i j;
   wn--;
   for (::i++)
   {
      w = NextWord();
      if (w==0) rfalse;
      j = 0;
      if (ow provides genitive && WordInProperty(w,ow,genitive))
      	 j = genitive;
      if (j==0 && ow provides words)
 	 j = ow.words(w,obj);
      if (j==0 && ow provides adj && WordInProperty(w,ow,adj))
	 j = adj;
      if (j==adj or article or articles) continue;
      if (j==genitive)
      {
	 return i+1;
      }
      rfalse;
   }
];

[ PNMatchWord w obj
    r arr l;
   if (0 == w or obj) rfalse;
   if (obj provides words && obj.#words &&
       (obj.&words-->0 ~= 0 or null || obj.#words>WORDSIZE))
      r = obj.words(w);
   if (r == 0)
   {
      arr = obj.&name;
      l = arr + (obj.#name);
      for ( : arr < l : arr = arr + WORDSIZE)
	 if (arr-->0 == w) { r = name; break; }
      if (r==name && ((w->#dict_par1) & 4))
	 r = plural;
   }
   if (r == 0)
   {
      arr = obj.&adj;
      l = arr + (obj.#adj);
      for ( : arr < l : arr = arr + WORDSIZE)
      	 if (arr-->0 == w) { r = adj; break; }
   }
   return r;
];

[ GetProp o p;
   if (~~(o && p && o provides p && o.#p)) rfalse;
   return o.&p-->0;
];
[ RunProp o p  a;
   if (~~(o && p && o provides p && o.#p)) rfalse;
   if (metaclass(o.&p-->0)==Routine)
      return o.p(a);
   if (metaclass(o.&p-->0)==String)
      print_ret (string) (o.&p-->0);
   return o.&p-->0;
];

[ GetGenitals obj
    x cl;
   if (obj has female) cl = Pussy;
   else                cl = Cock;
   objectloop (x in obj)
      if (x ofclass cl) return x;
   rfalse;
];
[ GetPart obj cl
    x;
   objectloop (x in obj)
      if (x ofclass cl) return x;
   rfalse;
];

! Replacements for VerbLibM.h (in AIF3.h)
Replace Objects1Sub;
Replace TasteSub;
Replace KissSub;
Replace TouchSub;
Replace SqueezeSub;
Replace InvSub;
Replace DisrobeSub;
Replace WearSub;
Replace AttemptToTakeObject;

! The article of clothing covering the current noun
Global noun_covering = 0;
! The recipient (owner of current noun) of a sex action
Global recipient = 0;

Class	BodyPart
 with	before
	[ x;
	  Drop, Insert, PutOn: if (self in player)
	     return QPrintRet("%Thats 1% part of your anatomy.",self);
	  Take, Remove, Transfer: if (self notin player)
	     return QPrintRet("%Thats 1% part of %gen 2% anatomy.",
			      self, parent(self));
	  Examine: if (location~=thedark && (x=CoverOf(self)) ~= 0)
	     switch (metaclass(self.description_covered))
	     {
	       Routine: return self.description_covered(x);
	       String: print_ret (string) (self.description_covered);
	       default: rfalse;
	     }
	],
	articles
	[ code p;
	   p = parent(self);
	   if (p==0) return -1;
	   if (p == player)
	   {
	      if (code) print "your";
	      else   print "Your";
	   }
	   else
	   {
	      if (code) print (the) p;
	      else print (The) p;
	      print "'s";
	   }
	   rtrue;
	],
	clothing_area 0,
	description_covered
	[ x;
	   return QPrintRet("%Tis 1% covered by %t 2%.",
			    self,x);
	]
 has 	scenery;

#ifndef Person;
Class	Person
 with 	orders
	[ x;
	   if (self==player) rfalse;
#ifdef USING_SEMEN;
	  Clean: if (IsSpunked(noun))
	  {
	     x = SpunkFor(noun);
	     if (x==0) rfalse;
	     action = ##Taste;
	     noun = x;
	     return TasteSub();
	  }
#endif;
	  Fuck:    return    FuckSub();
	  Taste:   return   TasteSub();
	  Touch:   return   TouchSub();
	  Squeeze: return SqueezeSub();
	  Kiss:    return    KissSub();
	  Hug:     return     HugSub();
	  Sod:     return     SodSub();
	  Titfuck: return TitFuckSub();
	  Wank:    return    WankSub();
	  Spank:   return   SpankSub();
	  Dress:   return   DressSub();
	  Strip:   return   StripSub();
	  Wear:
	   if (multiple_object-->0 > 1)
	   {
	      for (x = 1: x <= multiple_object-->0: x++)
	      {
		 noun = multiple_object-->x;
		 print (name) noun,": ";
		 WearSub();
	      }
	      rtrue;
	   }
	   return    WearSub();
	  Disrobe: if (multiple_object-->0 > 1)
	   {
	      for (x = 1: x <= multiple_object-->0: x++)
	      {
		 noun = multiple_object-->x;
		 print (name) noun,": ";
		 DisrobeSub();
	      }
	      rtrue;
	   }
 	   return DisrobeSub();
	  Eat: if (noun ofclass Pussy || noun ofclass Ass)
	  {
	     action = ##Taste;
	     return TasteSub();
	  }
	   if (noun has animate && noun has female)
	   {
	      action = ##Taste;
	      return TasteSub();
	   }
	  Attack:  if (verb_word=='spank' or 'flog' or 'hit'
		       && noun ofclass Ass)
	  {
	     action = ##Spank;
	     return SpankSub();
	  }
	  Give:
	   switch (noun)
	   {
	     blowjob:
 	      x = GetPart(second,cock);
	      if (x==0) rfalse;
	      action = ##Taste;
	      noun = x;
	      second = 0;
	      return TasteSub();
	     headjob:
	      x = GetGenitals(second);
	      if (x==0) rfalse;
	      action = ##Taste;
	      noun = x;
	      second = 0;
	      return TasteSub();
	     handjob:
	      x = GetGenitals(second);
	      if (x==0) rfalse;
	      action = ##Touch;
	      noun = x;
	      second = 0;
	      return TouchSub();
	   }
	],
	last_worn 0 0 0 0 0 0 0 0,
	arousal 0,
	org_at 40,
	arouse
	[ n;
	   self.arousal = self.arousal + n;
	   ! If self.arousal has just increased to
	   !  self.erect_at then boost it one more
	   !  to make sure it's still erect in the
	   !  subsequent turn.
	   if (n>0 && self provides erect_at
	       && self.arousal==self.erect_at)
	      self.arousal++;
	   return self.arousal;
	],
	block refalse,
	block_orders refalse,
	time_passes
	[;
	   if (self.arousal>0)
	      self.arousal--;
	   if (self.arousal<0)
	      self.arousal++;
	   if (self has female)
	   {
	      if (self.org_at>f_default_org_at)
		 self.org_at--;
	   }
	   else
	   {
	      if (self.org_at>m_default_org_at)
	      	 self.org_at--;
	   }
	],
	before_implicit
	[;
	  Take: if (action_to_be==##Eat && self has female)
	     return 2;
	],
	before
	[;
	  Eat: if (self has female) <<Taste self>>;
	],
 has 	animate transparent;
   #endif;

Class	Clothes
 with 	clothing_area 0,
	clothing_level 2,
	covered_by 0,
	before
	[ n;
	  LookUnder:
	   if (self in player && self has worn)
	   {
	      n = UnderClothes(self);
	      if (n) return QPR("Under %t 1% %is 2% %a 2%.",
				self, n);
	      "You find nothing of interest.";
	   }
	  Examine: if (location~=thedark && nounCover())
	     "You can't see ", (thatorthose) noun,
		 " under ",(the) noun_covering,".";
	],
 has 	clothing;

! ListWearing(obj, fl, nlf)
!  obj - person to list worn clothes of
!  fl - true: remain silent if obj is naked
!       false: print "The obj is naked" if naked
!  nlf - do not end with new line if anything is printed.
[ ListWearing obj fl nlf
    x f;
   f = 0;
   objectloop (x in obj) if (x hasnt scenery)
   {
      if (x has worn && IsCovered(x)==0)
      {
	 f = true;
	 give x ~concealed;
      }
      else give x concealed;
   }
   if (f)
   {
      QPrint("%Tis 1% wearing ",obj);
      WriteListFrom(child(obj),ENGLISH_BIT|CONCEAL_BIT,1);
      print (char)'.';
      if (nlf) print (char)' '; else  new_line;
   }
   objectloop (x in obj) if (x hasnt worn) give x ~concealed;
   if (f) rtrue;
   if (fl) rfalse;
   QPrint("%Tis 1% naked.",obj);
   if (nlf) print (char)' '; else  new_line;
];
! as above.
! If fl==2 then
!  print "Tis naked" but not "carrying nothing".
! If pron then use pronouns
[ ListWearingAndCarrying obj fl nlf pron
    x c w;
   c = 0; w = 0;
   objectloop (x in obj) if (x hasnt scenery)
   {
      if (x has worn)
      {
	 if (isCovered(x))
	    give x concealed;
	 else
	 {
	    w++;
	    give x ~concealed;
	 }
      }
      else { c++; give x concealed; }
   }
   if (c==0 && w==0)
   {
      objectloop (x in obj) if (x hasnt worn) give x ~concealed;
      if (fl==1) rfalse;
      if (pron)
      {
	 if (fl==2) QPrint("%Heis 1% naked.", obj);
	 else QPrint("%Heis 1% naked and carrying nothing.", obj);
      }
      else
      {
      	 if (fl==2) QPrint("%Tis 1% naked.", obj);
      	 else QPrint("%Tis 1% naked and carrying nothing.",obj);
      }
      if (nlf) print (char)' '; else  new_line;
      rtrue;
   }
   if (w)
   {
      if (pron) QPrint("%Heis 1% wearing ", obj);
      else QPrint("%Tis 1% wearing ",obj);
      WriteListFrom(child(obj),ENGLISH_BIT|CONCEAL_BIT,1);
      print (char)'.';
   }
   else if (fl~=1)
   {
      if (pron) QPrint("%Heis 1% naked.", obj);
      else QPrint("%Tis 1% naked.",obj);
   }
   if (c==0)
   {
      objectloop (x in obj) if (x hasnt worn) give x ~concealed;
      if (fl==0) QPrint(" %Heis 1% carrying nothing.",obj);
      if (nlf) print (char)' '; else  new_line;
      rtrue;
   }
   if (w || fl~=1) QPrint(" %Heis 1% carrying ",obj);
   else
   {
      if (pron) QPrint("%Heis 1% carrying ", obj);
      else QPrint("%Tis 1% carrying ",obj);
   }
   objectloop (x in obj)
      if (x has worn) give x concealed;
      else  give x ~concealed;
   WriteListFrom(child(obj),ENGLISH_BIT|CONCEAL_BIT|PARTINV_BIT,1);
   print (char)'.';
   if (nlf) print (char)' '; else  new_line;
   objectloop (x in obj)
      if (x has worn && IsCovered(x)==0) give x ~concealed;
];

[ Aarticles code;
   if (code) print (char)'a';
   else print (char)'A';
];

Object	gj_container;
Object	-> blowjob "blow-job"
 with   articles Aarticles, ! "A" "a" "a",
	words
	[w;
	   switch (w)
	   {
	     'blow': if (WordAt(wn)=='job') return name;
	     'job': return adj;
	     'blow-job', 'blowjob': return name;
	   }
	],
	before_implicit
	[;
	  Take: if (action_to_be==##Give) return 2;
	],
	before
	[ x;
	  Give: x = getPart(second,Cock);
	   if (x==0)
	      return QPR("You can't give that to %t s%.");
	   <<Taste x>>;
	];
Object	-> headjob "head"
 with 	parse_name
	[;
	   if (indef_owner) rfalse;
	   if (indef_type&MY_BIT) rfalse;
	   return (NextWord()=='head');
	],
	before_implicit
	[;
	  Take: if (action_to_be==##Give) return 2;
	],
	before
	[ x;
	  Give: x = getGenitals(second);
	   if (x==0)
	      return QPR("You can't give that to %t s%.");
	   <<Taste x>>;
	],
 has 	proper;
Object	-> handjob "hand-job"
 with 	articles Aarticles, ! "A" "a" "a",
	words
	[w;
	   switch (w)
	   {
	     'hand': if (WordAt(wn)=='job') return name;
	     'job': return adj;
	     'hand-job', 'handjob': return name;
	   }
	],
	before_implicit
	[;
	  Take: if (action_to_be==##Give) return 2;
	],
	before
	[ x;
	  Give: x = getGenitals(second);
	   if (x==0)
	      return QPR("You can't give that to %t s%.");
	   <<Touch x>>;
	];

System_file;

Constant FEET_AREA   $0001; ! shoes, socks
Constant LEGS_AREA   $0002; ! trousers
Constant ASS_AREA    $0004; ! underpants, trousers
Constant CROTCH_AREA $0008; ! underpants, trousers
Constant BELLY_AREA  $0010; ! shirt, t-shirt
Constant CHEST_AREA  $0020; ! shirt, t-shirt, bra
Constant ARMS_AREA   $0040; ! shirt
Constant HANDS_AREA  $0080; ! gloves
Constant FACE_AREA   $0100; ! gag, mask
Constant HEAD_AREA   $0200; ! hat

Constant ALL_AREA    $03ff; ! spacesuit

Class	Breasts class BodyPart
 with 	short_name "breasts",
	clothing_area CHEST_AREA,
	words
	[w;
	   switch (w)
	   {
	     'breasts', 'boobs', 'tits', 'chest', 'bosom': return name;
	     'breast', 'boob', 'tit': return name;
	   }
	],
 has 	pluralname;

Class	Face class BodyPart
 with 	short_name "face",
	clothing_area FACE_AREA,
	words
	[ w;
	   if (w=='face') return name;
	   rfalse;
	];

Class	Pussy class BodyPart
 with 	short_name "pussy",
	clothing_area CROTCH_AREA,
	words
	[w;
	   switch (w)
	   {
	     'pussy', 'vagina', 'twat', 'cunt', 'minge', 'vulva', 'slit':
	      return name;
	   }
	],
	before
	[;
	  Eat: <<Taste self>>;
	  Receive: if (receive_action == ##Insert && noun in player)
	     <<Fuck noun>>;
	],
	before_implicit
	[;
	  Take: if (action_to_be == ##Eat) return 2;
	];

Class	Mouth class BodyPart
 with 	short_name "mouth",
	clothing_area FACE_AREA,
	words
	[w;
	   switch (w)
	   {
	     'mouth', 'lips': return name;
	   }
	],
	before
	[;
	  Receive: if (receive_action == ##Insert) <<Taste noun>>;
	];

Class	Cock class BodyPart
 with 	short_name "penis",
	clothing_area CROTCH_AREA,
	is_erect retrue,
	words
	[w;
	   switch (w)
	   {
	     'cock', 'dick', 'penis': return name;
	     'erection','hardon': if (self.is_erect()) return name;
	     'erect','stiff','hard': if (self.is_erect()) return adj;
	   }
	];

Class	Ass class BodyPart
 with 	short_name "ass",
	clothing_area ASS_AREA,
	before
	[;
	  Attack: if (verb_word=='spank' or 'flog' or 'hit')
	     <<Spank self>>;
	  Eat: <<Taste self>>;
	  Receive: if (receive_action == ##Insert)
	     return QPR("%Thatsnot n% an appropriate thing
			to put in your ass.");
	],
	words
	[w;
	   switch (w)
	   {
	     'ass', 'arse', 'butt', 'bum','rear', 'derriere',
	     'asshole', 'anus', 'arsehole', 'bottom': return name;
	   }
	],
	before_implicit
	[;
	  Take: if (action_to_be == ##Eat) return 2;
	];

Class	Balls class BodyPart
 with 	short_name "balls",
	clothing_area CROTCH_AREA,
	words
	[ w;
 	   switch (w)
	   {
	     'balls', 'bollocks', 'testes', 'testicles',
	     'ball', 'bollock', 'testicle': return name;
	   }
	]
 has 	pluralname;
